SystemOrganization addCategory: #'Alien-CoreTest'!

TestCase subclass: #AlienSunit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alien-CoreTest'!

!AlienSunit class methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 12:35'!
testParser
	"Just confirm it will parse"
	
	(Parser new parse: (MethodNode sourceCodeAt: #primitiveErrorVariableName) class: Parser) primitiveErrorVariableName.
	(Parser new parse: 'foo <primitive: 111 error: ''foo''> self primitiveFailed' class: Object) primitiveErrorVariableName.
	(Parser new parse: 'foo <primitive: 111 error: foo> self primitiveFailed' class: Object) primitiveErrorVariableName.
	(Parser new parse: 'foo <primitive: 111> self primitiveFailed' class: Object) primitiveErrorVariableName.
	(Parser new parse: 'foo <primitive: 111 error: foo> self primitiveFailed' class: Object) generate.
! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 21:57'!
testAccessing
	| alien |
	alien := Alien newCString: 'foo'.
	alien freeAfter: [:cstring | 
			self should: [cstring dataSize = 4].
			self should: [cstring strcpy = 'foo']].
	self should: [alien address = 0].
	self should: [alien dataSize = 0].! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/6/2008 14:07'!
testAccessorsFailure
	| alien |
	alien := Alien newC: 1. 
	self should: [alien signedByteAt: 2 put: 16r80] raise: Error.
	self should: [alien signedShortAt: 1 put: 16r80] raise: Error.
	self should: [alien signedLongAt: 1 put: 16r80] raise: Error.
	self should: [alien signedLongLongAt: 1 put: 16r80] raise: Error.
	self should: [alien unsignedByteAt: 2 put: 16r80] raise: Error.
	self should: [alien unsignedShortAt: 1 put: 16r80] raise: Error.
	self should: [alien unsignedLongAt: 1 put: 16r80] raise: Error.
	self should: [alien unsignedLongLongAt: 1 put: 16r80] raise: Error.
	self should: [alien floatAt: 1 put: 1.0] raise: Error.
	self should: [alien doubleAt: 1 put: 1.0] raise: Error.
	self should: [alien signedByteAt: 2 ] raise: Error.
	self should: [alien signedShortAt: 1 ] raise: Error.
	self should: [alien signedLongAt: 1] raise: Error.
	self should: [alien signedLongLongAt: 1] raise: Error.
	self should: [alien unsignedByteAt: 2] raise: Error.
	self should: [alien unsignedShortAt: 1] raise: Error.
	self should: [alien unsignedLongAt: 1] raise: Error.
	self should: [alien unsignedLongLongAt: 1] raise: Error.
	self should: [alien floatAt: 1 ] raise: Error.
	self should: [alien doubleAt: 1 ] raise: Error.
	alien free.
	alien := Alien newC: 2. 
	alien signedByteAt: 1 put: 16r007F.
	alien signedShortAt: 1 put: 16r7FFF.
	self should: [alien signedLongAt: 1 put: 16r80] raise: Error.
	self should: [alien signedLongLongAt: 1 put: 16r80] raise: Error.
	alien unsignedByteAt: 2 put: 16r80.
	alien unsignedShortAt: 1 put: 16r7FFF.
	self should: [alien unsignedLongAt: 1 put: 16r80] raise: Error.
	self should: [alien unsignedLongLongAt: 1 put: 16r80] raise: Error.
	self should: [alien floatAt: 1 put: 1.0] raise: Error.
	self should: [alien doubleAt: 1 put: 1.0] raise: Error.
	alien signedByteAt: 2.
	alien signedShortAt: 1.
	self should: [alien signedLongAt: 1] raise: Error.
	self should: [alien signedLongLongAt: 1] raise: Error.
	alien unsignedByteAt: 2.
	alien unsignedShortAt: 1.
	self should: [alien unsignedLongAt: 1] raise: Error.
	self should: [alien unsignedLongLongAt: 1] raise: Error.
	self should: [alien floatAt: 1 ] raise: Error.
	self should: [alien doubleAt: 1 ] raise: Error.
	alien free.
	alien := Alien newC: 3. 
	alien signedByteAt: 1 put: 16r007F.
	alien signedShortAt: 1 put: 16r7FFF.
	self should: [alien signedLongAt: 1 put: 16r80] raise: Error.
	self should: [alien signedLongLongAt: 1 put: 16r80] raise: Error.
	alien unsignedByteAt: 2 put: 16r80.
	alien unsignedShortAt: 1 put: 16r7FFF.
	self should: [alien unsignedLongAt: 1 put: 16r80] raise: Error.
	self should: [alien unsignedLongLongAt: 1 put: 16r80] raise: Error.
	self should: [alien floatAt: 1 put: 1.0] raise: Error.
	self should: [alien doubleAt: 1 put: 1.0] raise: Error.
	alien signedByteAt: 2.
	alien signedShortAt: 1.
	self should: [alien signedLongAt: 1] raise: Error.
	self should: [alien signedLongLongAt: 1] raise: Error.
	alien unsignedByteAt: 2.
	alien unsignedShortAt: 1.
	self should: [alien unsignedLongAt: 1] raise: Error.
	self should: [alien unsignedLongLongAt: 1] raise: Error.
	self should: [alien floatAt: 1 ] raise: Error.
	self should: [alien doubleAt: 1 ] raise: Error.
	alien free.
	alien := Alien newC: 4. 
	alien signedByteAt: 1 put: 16r007F.
	alien signedShortAt: 1 put: 16r7FFF.
	alien signedLongAt: 1 put: 16r80.
	self should: [alien signedLongLongAt: 1] raise: Error.
	alien unsignedByteAt: 2 put: 16r80.
	alien unsignedShortAt: 1 put: 16r7FFF.
	alien unsignedLongAt: 1 put: 16r80.
	self should: [alien unsignedLongLongAt: 1 put: 16r80] raise: Error.
	alien floatAt: 1 put: 1.0.
	self should: [alien doubleAt: 1 put: 1.0] raise: Error.
	alien signedByteAt: 2.
	alien signedShortAt: 1.
	alien signedLongAt: 1.
	self should: [alien signedLongLongAt: 1] raise: Error.
	alien unsignedByteAt: 2.
	alien unsignedShortAt: 1.
	alien unsignedLongAt: 1.
	self should: [alien unsignedLongLongAt: 1] raise: Error.
	alien floatAt: 1.
	self should: [alien doubleAt: 1 ] raise: Error.
	alien free.
	alien := Alien newC: 8. 
	alien signedByteAt: 1 put: 16r007F.
	alien signedShortAt: 1 put: 16r7FFF.
	alien signedLongAt: 1 put: 16r80.
	alien signedLongLongAt: 1.
	alien unsignedByteAt: 2 put: 16r80.
	alien unsignedShortAt: 1 put: 16r7FFF.
	alien unsignedLongAt: 1 put: 16r80.
	alien unsignedLongLongAt: 1 put: 16r80.
	alien floatAt: 1 put: 1.0.
	alien doubleAt: 1 put: 1.0.
	alien signedByteAt: 2.
	alien signedShortAt: 1.
	alien signedLongAt: 1.
	alien signedLongLongAt: 1.
	alien unsignedByteAt: 2.
	alien unsignedShortAt: 1.
	alien unsignedLongAt: 1.
	alien unsignedLongLongAt: 1.
	alien floatAt: 1.
	alien doubleAt: 1.
	alien free.
! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 23:43'!
testAtAddress
	| alien address alias |
	alien := Alien newCString: 'foo'.
	address := alien address.
	"This means alias and alien both point to the same address"
	alias := Alien atAddress: address dataSize: 4.
	self should: [alias dataSize = 4].
	self should: [alias strcpy = 'foo'].
	alien free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/25/2008 22:08'!
testByte
	| byte |
	byte := Alien newC:1.
	0 to: 255 do: 
		[:i  | byte unsignedByteAt: 1 put: i.
		self should: [(byte unsignedByteAt: 1) = i]].
	-128 to: 127 do: 
		[:j |  byte signedByteAt: 1 put: j.
		self should: [(byte signedByteAt: 1) = j]].
	-255 to: -129 do: 
		[:k |  self should: [byte signedByteAt: 1 put: k] raise: Error].
	128 to: 255 do: 
		[:k |  self should: [byte signedByteAt: 1 put: k] raise: Error].! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 23:44'!
testByteAccessors
	| alien |
	alien := Alien newC: 2. 
	alien signedByteAt: 1 put: 16r7F.
	self should: [(alien signedByteAt: 1) = 16r7F].
	self should: [(alien asSignedByte) = 16r7F].
	self should: [alien signedByteAt: 1 put: 16r80] raise: Error.
	alien signedByteAt: 2 put: 16r00.
	alien signedByteAt: 1 put: 16r7F.
	self should: [(alien signedByteAt: 2) = 16r00].
	alien signedByteAt: 1 put: -1*16r80.
	self should: [(alien signedByteAt: 1) =  (-1*16r80)].
	self should: [alien signedByteAt: 1 put: -1*16r81] raise: Error.
	alien unsignedByteAt: 1 put: 16r7F.
	self should: [(alien signedByteAt: 1) = 16r7F].
	alien unsignedByteAt: 1 put: 16r80.
	self should: [(alien asSignedByte) = -128].
	self should: [(alien signedByteAt: 1) = -128].
	alien unsignedByteAt: 1 put: 16r81.
	self should: [(alien signedByteAt: 1) = -127].
	alien unsignedByteAt: 1 put: 16r7F.
	self should: [(alien unsignedByteAt: 1) = 16r7F].
	alien unsignedByteAt: 1 put: 16r80.
	self should: [(alien unsignedByteAt: 1) = 16r80].
	alien unsignedByteAt: 1 put: 16r81.
	self should: [(alien unsignedByteAt: 1) = 16r81].
	alien free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/8/2008 14:34'!
testCallingSquenceChar10Long2
	| alien1 alien2 alien3 alien4 result who alien5 alien6 alien7 alien8 alien9 alien10 alien11 alien12 |
	
	alien1 := Alien newC: 1. 
	alien2 := Alien newC: 1. 
	alien3 := Alien newC: 1. 
	alien4 := Alien newC: 1. 
	alien5 := Alien newC: 1. 
	alien6 := Alien newC: 1. 
	alien7 := Alien newC: 1. 
	alien8 := Alien newC: 1. 
	alien9 := Alien newC: 1. 
	alien10 := Alien newC: 1. 
	alien11 := Alien newC: 8. 
	alien12 := Alien newC: 8. 

	alien1 signedByteAt: 1 put: 1.
	alien2 signedByteAt: 1 put: 2. 
	alien3 signedByteAt: 1 put: 3.
	alien4 signedByteAt: 1 put: 4.
	alien5 signedByteAt: 1 put: 5.
	alien6 signedByteAt: 1 put: 6.
	alien7 signedByteAt: 1 put: 7.
	alien8 signedByteAt: 1 put: 8.
	alien9 signedByteAt: 1 put: 9.
	alien10 signedByteAt: 1 put: 10.
	alien11 signedLongLongAt: 1 put: 11.
	alien12 signedLongLongAt: 1 put: 12.
	
	who := Alien lookup: 'ffiTestLongLong10a2' inLibrary: 'IA32ABI'.
	result := who primFFICallResult: (Alien new: 8)
		with: alien1
		with: alien2
		with: alien3
		with: alien4
		with: alien5
		with: alien6
		with: alien7
		with: alien8
		with: alien9
		with: alien10
		with: alien11
		with: alien12.
		self should: [(result signedLongLongAt: 1) = (1+2+3+4+5+6+7+8+9+10+11+12)].
	alien1 free.
	alien2 free.
	alien3 free.
	alien4 free.
	alien5 free.
	alien6 free.
	alien7 free.
	alien8 free.
	alien9 free.
	alien10 free.
	alien11 free.
	alien12 free.
! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/7/2008 00:10'!
testCallingSquenceChar2LongLong2
	| alien1 alien2 result who alien3 alien4 |
	
	alien1 := Alien newC: 8. 
	alien2 := Alien newC: 8. 
	alien3 := Alien newC: 1. 
	alien4 := Alien newC: 1. 
	
	alien1 signedLongLongAt: 1 put: 1.
	alien2 signedLongLongAt: 1 put: 2. 
	alien3 signedByteAt: 1 put: 3. 
	alien4 signedByteAt: 1 put: 4. 
	
	who := Alien lookup: 'ffiTestLongLonga2' inLibrary: 'IA32ABI'.
	result := who primFFICallResult: (Alien new: 8)
		with: alien3
		with: alien4
		with: alien1
		with: alien2.

	self should: [(result signedLongLongAt: 1) = (1+2+3+4)].
	alien1 free.
	alien2 free.
	alien3 free.
! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/8/2008 14:32'!
testCallingSquenceChar8Long2
	| alien1 alien2 alien3 alien4 result who alien5 alien6 alien7 alien8 alien9 alien10 |
	
	alien1 := Alien newC: 1.
	alien2 := Alien newC: 1.
	alien3 := Alien newC: 1. 
	alien4 := Alien newC: 1. 
	alien5 := Alien newC: 1. 
	alien6 := Alien newC: 1. 
	alien7 := Alien newC: 1. 
	alien8 := Alien newC: 1. 
	alien9 := Alien newC: 8. 
	alien10 := Alien newC: 8. 

	alien1 signedByteAt: 1 put: 1.
	alien2 signedByteAt: 1 put: 2. 
	alien3 signedByteAt: 1 put: 3.
	alien4 signedByteAt: 1 put: 4.
	alien5 signedByteAt: 1 put: 5.
	alien6 signedByteAt: 1 put: 6.
	alien7 signedByteAt: 1 put: 7.
	alien8 signedByteAt: 1 put: 8.
	alien9 signedLongLongAt: 1 put: 9.
	alien10 signedLongLongAt: 1 put: 10.
	
	who := Alien lookup: 'ffiTestLongLong8' inLibrary: 'IA32ABI'.
	result := who primFFICallResult: (Alien new: 8)
		with: alien1
		with: alien2
		with: alien3
		with: alien4
		with: alien5
		with: alien6
		with: alien7
		with: alien8
		with: alien9
		with: alien10.
	self should: [(result signedLongLongAt: 1) = (1+2+3+4+5+6+7+8+9+10)].
	alien1 free.
	alien2 free.
	alien3 free.
	alien4 free.
	alien5 free.
	alien6 free.
	alien7 free.
	alien8 free.
	alien9 free.
	alien10 free.
! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/8/2008 14:31'!
testCallingSquenceChar9Long2
	| alien1 alien2 alien3 alien4 result who alien5 alien6 alien7 alien8 alien9 alien10 alien11 |
	
	alien1 := Alien newC: 1. 
	alien2 := Alien newC: 1. 
	alien3 := Alien newC: 1. 
	alien4 := Alien newC: 1. 
	alien5 := Alien newC: 1. 
	alien6 := Alien newC: 1. 
	alien7 := Alien newC: 1. 
	alien8 := Alien newC: 1. 
	alien9 := Alien newC: 1. 
	alien10 := Alien newC: 8. 
	alien11 := Alien newC: 8. 

	alien1 signedByteAt: 1 put: 1.
	alien2 signedByteAt: 1 put: 2. 
	alien3 signedByteAt: 1 put: 3.
	alien4 signedByteAt: 1 put: 4.
	alien5 signedByteAt: 1 put: 5.
	alien6 signedByteAt: 1 put: 6.
	alien7 signedByteAt: 1 put: 7.
	alien8 signedByteAt: 1 put: 8.
	alien9 signedByteAt: 1 put: 9.
	alien10 signedLongLongAt: 1 put: 10.
	alien11 signedLongLongAt: 1 put: 11.
	
	who := Alien lookup: 'ffiTestLongLong9a1' inLibrary: 'IA32ABI'.
	result := who primFFICallResult: (Alien new: 8)
		with: alien1
		with: alien2
		with: alien3
		with: alien4
		with: alien5
		with: alien6
		with: alien7
		with: alien8
		with: alien9
		with: alien10
		with: alien11.
	self should: [(result signedLongLongAt: 1) = (1+2+3+4+5+6+7+8+9+10+11)].
	alien1 free.
	alien2 free.
	alien3 free.
	alien4 free.
	alien5 free.
	alien6 free.
	alien7 free.
	alien8 free.
	alien9 free.
	alien10 free.
	alien11 free.
! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/6/2008 16:32'!
testCallingSquenceCharLongLong2
	| alien1 alien2 result who alien3 |
	
	alien1 := Alien newC: 8. 
	alien2 := Alien newC: 8. 
	alien3 := Alien newC: 1. 
	
	alien1 signedLongLongAt: 1 put: 1.
	alien2 signedLongLongAt: 1 put: 2. 
	alien3 signedByteAt: 1 put: 3. 
	
	who := Alien lookup: 'ffiTestLongLonga1' inLibrary: 'IA32ABI'.
	result := who primFFICallResult: (Alien new: 8)
		with: alien3
		with: alien1
		with: alien2.

	self should: [(result signedLongLongAt: 1) = (1+2+3)].
	alien1 free.
	alien2 free.
	alien3 free.
! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/8/2008 14:19'!
testCallingSquenceChars
	| alien1 alien2 alien3 alien4 result who |
	
	alien1 := Alien newC: 1. 
	alien2 := Alien newC: 1. 
	alien3 := Alien newC: 1. 
	alien4 := Alien newC: 1. 
	
	alien1 signedByteAt: 1 put: 1.
	alien2 signedByteAt: 1 put: 20. 
	alien3 signedByteAt: 1 put: 30.
	alien4 signedByteAt: 1 put: 40.
	
	who := Alien lookup: 'ffiTestChars' inLibrary: 'IA32ABI'.
	result := who primFFICallResult: (Alien new: 1)
		with: alien1
		with: alien2
		with: alien3
		with: alien4.
	self should: [(result signedByteAt: 1) = (1+20+30+40)].
	alien1 free.
	alien2 free.
	alien3 free.
	alien4 free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/12/2008 20:04'!
testCallingSquenceDoubles14
	| alien1 alien2 alien3 alien4 result who alien5 alien6 alien7 alien8 alien9 alien10 alien11 alien12 alien13 array alien14 parmTypes |
	alien1 := Alien newC: 8.
	alien2 := Alien newC: 8.
	alien3 := Alien newC: 8.
	alien4 := Alien newC: 8.
	alien5 := Alien newC: 8.
	alien6 := Alien newC: 8.
	alien7 := Alien newC: 8.
	alien8 := Alien newC: 8.
	alien9 := Alien newC: 8.
	alien10 := Alien newC: 8.
	alien11 := Alien newC: 8.
	alien12 := Alien newC: 8.
	alien13 := Alien newC: 8.
	alien14 := Alien newC: 8.
	alien1 
		doubleAt: 1
		put: 1.0.
	alien2 
		doubleAt: 1
		put: 20.0.
	alien3 
		doubleAt: 1
		put: 30.0.
	alien4 
		doubleAt: 1
		put: 40.0.
	alien5 
		doubleAt: 1
		put: 50.0.
	alien6 
		doubleAt: 1
		put: 60.0.
	alien7 
		doubleAt: 1
		put: 70.0.
	alien8 
		doubleAt: 1
		put: 80.0.
	alien9 
		doubleAt: 1
		put: 90.0.
	alien10 
		doubleAt: 1
		put: 100.0.
	alien11 
		doubleAt: 1
		put: 110.0.
	alien12 
		doubleAt: 1
		put: 120.0.
	alien13 
		doubleAt: 1
		put: 130.0.
	alien14 
		doubleAt: 1
		put: 140.0.
	array := Array new: 14.
	array 
		at: 1
		put: alien1.
	array 
		at: 2
		put: alien2.
	array 
		at: 3
		put: alien3.
	array 
		at: 4
		put: alien4.
	array 
		at: 5
		put: alien5.
	array 
		at: 6
		put: alien6.
	array 
		at: 7
		put: alien7.
	array 
		at: 8
		put: alien8.
	array 
		at: 9
		put: alien9.
	array 
		at: 10
		put: alien10.
	array 
		at: 11
		put: alien11.
	array 
		at: 12
		put: alien12.
	array 
		at: 13
		put: alien13.
	array 
		at: 14
		put: alien14.
	parmTypes := ByteArray new: 14.
	parmTypes atAllPut: 8.

	who := Alien 
		lookup: 'ffiTestDoubles14'
		inLibrary: 'IA32ABI'.
	result := who 
		primFFICallDoubleResult: (Alien new: 8)
		floatParmsSignature: parmTypes
		withArguments: array.
	self should: 
		[ (result doubleAt: 1) = (1 + 20 + 30 + 40 + 50 + 60 + 70 + 80 + 90 + 100 + 110 + 120 + 130 + 140) asFloat ].
	alien1 free.
	alien2 free.
	alien3 free.
	alien4 free.
	alien5 free.
	alien6 free.
	alien7 free.
	alien8 free.
	alien9 free.
	alien10 free.
	alien11 free.
	alien12 free.
	alien13 free.
	alien14 free! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/12/2008 19:54'!
testCallingSquenceDoubles2
	| alien1 alien2 result who |
	alien1 := Alien newC: 8.
	alien2 := Alien newC: 8.
	alien1 
		doubleAt: 1
		put: 1.0.
	alien2 
		doubleAt: 1
		put: 2.0.
	who := Alien 
		lookup: 'ffiTestDoubles'
		inLibrary: 'IA32ABI'.
	result := who 
		primFFICallDoubleResult: (Alien new: 8)
		floatParmsSignature: (ByteArray 
				with: 8
				with: 8)
		with: alien1
		with: alien2.
	self should: [ (result doubleAt: 1) = (1.0 + 2.0) ].
	alien1 free.
	alien2 free! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/12/2008 19:55'!
testCallingSquenceFloats13
	| alien1 alien2 alien3 alien4 result who alien5 alien6 alien7 alien8 alien9 alien10 alien11 alien12 alien13 array parmTypes |
	alien1 := Alien newC: 4.
	alien2 := Alien newC: 4.
	alien3 := Alien newC: 4.
	alien4 := Alien newC: 4.
	alien5 := Alien newC: 4.
	alien6 := Alien newC: 4.
	alien7 := Alien newC: 4.
	alien8 := Alien newC: 4.
	alien9 := Alien newC: 4.
	alien10 := Alien newC: 4.
	alien11 := Alien newC: 4.
	alien12 := Alien newC: 4.
	alien13 := Alien newC: 4.
	alien1 
		floatAt: 1
		put: 1.0.
	alien2 
		floatAt: 1
		put: 20.0.
	alien3 
		floatAt: 1
		put: 30.0.
	alien4 
		floatAt: 1
		put: 40.0.
	alien5 
		floatAt: 1
		put: 50.0.
	alien6 
		floatAt: 1
		put: 60.0.
	alien7 
		floatAt: 1
		put: 70.0.
	alien8 
		floatAt: 1
		put: 80.0.
	alien9 
		floatAt: 1
		put: 90.0.
	alien10 
		floatAt: 1
		put: 100.0.
	alien11 
		floatAt: 1
		put: 110.0.
	alien12 
		floatAt: 1
		put: 120.0.
	alien13 
		floatAt: 1
		put: 130.0.
	array := Array new: 13.
	array 
		at: 1
		put: alien1.
	array 
		at: 2
		put: alien2.
	array 
		at: 3
		put: alien3.
	array 
		at: 4
		put: alien4.
	array 
		at: 5
		put: alien5.
	array 
		at: 6
		put: alien6.
	array 
		at: 7
		put: alien7.
	array 
		at: 8
		put: alien8.
	array 
		at: 9
		put: alien9.
	array 
		at: 10
		put: alien10.
	array 
		at: 11
		put: alien11.
	array 
		at: 12
		put: alien12.
	array 
		at: 13
		put: alien13.
	parmTypes := ByteArray new: 13.
	parmTypes atAllPut: 4.
	who := Alien 
		lookup: 'ffiTestFloats13'
		inLibrary: 'IA32ABI'.
	result := who 
		primFFICallFloatResult: (Alien new: 4)
		floatParmsSignature: parmTypes
		withArguments: array.
	self should: 
		[ (result floatAt: 1) = (1 + 20 + 30 + 40 + 50 + 60 + 70 + 80 + 90 + 100 + 110 + 120 + 130) asFloat ].
	alien1 free.
	alien2 free.
	alien3 free.
	alien4 free.
	alien5 free.
	alien6 free.
	alien7 free.
	alien8 free.
	alien9 free.
	alien10 free.
	alien11 free.
	alien12 free.
	alien13 free! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/12/2008 20:06'!
testCallingSquenceFloats14
	| alien1 alien2 alien3 alien4 result who alien5 alien6 alien7 alien8 alien9 alien10 alien11 alien12 alien13 array alien14 parmTypes |
	alien1 := Alien newC: 4.
	alien2 := Alien newC: 4.
	alien3 := Alien newC: 4.
	alien4 := Alien newC: 4.
	alien5 := Alien newC: 4.
	alien6 := Alien newC: 4.
	alien7 := Alien newC: 4.
	alien8 := Alien newC: 4.
	alien9 := Alien newC: 4.
	alien10 := Alien newC: 4.
	alien11 := Alien newC: 4.
	alien12 := Alien newC: 4.
	alien13 := Alien newC: 4.
	alien14 := Alien newC: 4.
	alien1 
		floatAt: 1
		put: 1.0.
	alien2 
		floatAt: 1
		put: 20.0.
	alien3 
		floatAt: 1
		put: 30.0.
	alien4 
		floatAt: 1
		put: 40.0.
	alien5 
		floatAt: 1
		put: 50.0.
	alien6 
		floatAt: 1
		put: 60.0.
	alien7 
		floatAt: 1
		put: 70.0.
	alien8 
		floatAt: 1
		put: 80.0.
	alien9 
		floatAt: 1
		put: 90.0.
	alien10 
		floatAt: 1
		put: 100.0.
	alien11 
		floatAt: 1
		put: 110.0.
	alien12 
		floatAt: 1
		put: 120.0.
	alien13 
		floatAt: 1
		put: 130.0.
	alien14 
		floatAt: 1
		put: 140.0.
	array := Array new: 14.
	array 
		at: 1
		put: alien1.
	array 
		at: 2
		put: alien2.
	array 
		at: 3
		put: alien3.
	array 
		at: 4
		put: alien4.
	array 
		at: 5
		put: alien5.
	array 
		at: 6
		put: alien6.
	array 
		at: 7
		put: alien7.
	array 
		at: 8
		put: alien8.
	array 
		at: 9
		put: alien9.
	array 
		at: 10
		put: alien10.
	array 
		at: 11
		put: alien11.
	array 
		at: 12
		put: alien12.
	array 
		at: 13
		put: alien13.
	array 
		at: 14
		put: alien14.
	parmTypes := ByteArray new: 14.
	parmTypes atAllPut: 4.
	
	who := Alien 
		lookup: 'ffiTestFloats14'
		inLibrary: 'IA32ABI'.
	result := who 
		primFFICallFloatResult: (Alien new: 4)
		floatParmsSignature: parmTypes
		withArguments: array.
	self should: 
		[ (result floatAt: 1) = (1 + 20 + 30 + 40 + 50 + 60 + 70 + 80 + 90 + 100 + 110 + 120 + 130 + 140) asFloat ].
	alien1 free.
	alien2 free.
	alien3 free.
	alien4 free.
	alien5 free.
	alien6 free.
	alien7 free.
	alien8 free.
	alien9 free.
	alien10 free.
	alien11 free.
	alien12 free.
	alien13 free.
	alien14 free! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/15/2008 09:53'!
testCallingSquenceFloats2
	| alien1 alien2 result who |
	
	alien1 := Alien newC: 4. 
	alien2 := Alien newC: 4. 
	
	alien1 floatAt: 1 put: 1.0.
	alien2 floatAt: 1 put: 2.0. 
	
	who := Alien lookup: 'ffiTestFloats' inLibrary: 'IA32ABI'.
	result := who primFFICallFloatResult: (Alien new: 4)
		floatParmsSignature: (ByteArray with: 4 with: 4)
		with: alien1
		with: alien2.
	self should: [(result floatAt: 1) = (1.0+2.0)].
	alien1 free.
	alien2 free.
! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/12/2008 20:05'!
testCallingSquenceFloats7
	| alien1 alien2 alien3 alien4 result who alien5 alien6 alien7 parmTypes |
	alien1 := Alien newC: 4.
	alien2 := Alien newC: 4.
	alien3 := Alien newC: 4.
	alien4 := Alien newC: 4.
	alien5 := Alien newC: 4.
	alien6 := Alien newC: 4.
	alien7 := Alien newC: 4.
	alien1 
		floatAt: 1
		put: 1.0.
	alien2 
		floatAt: 1
		put: 20.0.
	alien3 
		floatAt: 1
		put: 30.0.
	alien4 
		floatAt: 1
		put: 40.0.
	alien5 
		floatAt: 1
		put: 50.0.
	alien6 
		floatAt: 1
		put: 60.0.
	alien7 
		floatAt: 1
		put: 70.0.
	parmTypes := ByteArray new: 7.
	parmTypes atAllPut: 4.
	who := Alien 
		lookup: 'ffiTestFloats7'
		inLibrary: 'IA32ABI'.
	result := who 
		primFFICallFloatResult: (Alien new: 4)
		floatParmsSignature: parmTypes
		with: alien1
		with: alien2
		with: alien3
		with: alien4
		with: alien5
		with: alien6
		with: alien7.
	self should: [ (result floatAt: 1) = (1 + 20 + 30 + 40 + 50 + 60 + 70) asFloat ].
	alien1 free.
	alien2 free.
	alien3 free.
	alien4 free.
	alien5 free.
	alien6 free.
	alien7 free! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/6/2008 16:17'!
testCallingSquenceInt
	| alien1 alien2 alien3 alien4 result who |
	
	alien1 := Alien newC: 4. 
	alien2 := Alien newC: 4. 
	alien3 := Alien newC: 4. 
	alien4 := Alien newC: 4. 
	
	alien1 signedLongAt: 1 put: 1.
	alien2 signedLongAt: 1 put: 20. 
	alien3 signedLongAt: 1 put: 30.
	alien4 signedLongAt: 1 put: 40.
	
	who := Alien lookup: 'ffiTestInts' inLibrary: 'IA32ABI'.
	result := who primFFICallResult: (Alien new: 4)
		with: alien1
		with: alien2
		with: alien3
		with: alien4.
	self should: [(result signedLongAt: 1) = (1+20+30+40)].
	alien1 free.
	alien2 free.
	alien3 free.
	alien4 free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/6/2008 16:26'!
testCallingSquenceInt8
	| alien1 alien2 alien3 alien4 result who alien5 alien6 alien7 alien8 |
	
	alien1 := Alien newC: 4. 
	alien2 := Alien newC: 4. 
	alien3 := Alien newC: 4. 
	alien4 := Alien newC: 4. 
	alien5 := Alien newC: 4. 
	alien6 := Alien newC: 4. 
	alien7 := Alien newC: 4. 
	alien8 := Alien newC: 4. 

	alien1 signedLongAt: 1 put: 1.
	alien2 signedLongAt: 1 put: 20. 
	alien3 signedLongAt: 1 put: 30.
	alien4 signedLongAt: 1 put: 40.
	alien5 signedLongAt: 1 put: 50.
	alien6 signedLongAt: 1 put: 60.
	alien7 signedLongAt: 1 put: 70.
	alien8 signedLongAt: 1 put: 80.
	
	who := Alien lookup: 'ffiTestInts8' inLibrary: 'IA32ABI'.
	result := who primFFICallResult: (Alien new: 4)
		with: alien1
		with: alien2
		with: alien3
		with: alien4
		with: alien5
		with: alien6
		with: alien7
		with: alien8.
	self should: [(result signedLongAt: 1) = (1+20+30+40+50+60+70+80)].
	alien1 free.
	alien2 free.
	alien3 free.
	alien4 free.
	alien5 free.	
	alien6 free.
	alien7 free.
	alien8 free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/16/2008 18:29'!
testCallingSquenceIntWithFloatArgs
	| alien1 alien2 alien3 alien4 result who |
	
	alien1 := Alien newC: 4. 
	alien2 := Alien newC: 4. 
	alien3 := Alien newC: 4. 
	alien4 := Alien newC: 4. 
	
	alien1 signedLongAt: 1 put: 1.
	alien2 signedLongAt: 1 put: 20. 
	alien3 signedLongAt: 1 put: 30.
	alien4 signedLongAt: 1 put: 40.
	
	who := Alien lookup: 'ffiTestInts' inLibrary: 'IA32ABI'.
	result := who primFFICallResult:  (Alien new: 4) 
		floatParmsSignature: (ByteArray with: 0 with: 0 with: 0 with: 0)
		withArguments: (Array with: alien1 with: alien2 with: alien3 with: alien4).
	self should: [(result signedLongAt: 1) = (1+20+30+40)].
	alien1 free.
	alien2 free.
	alien3 free.
	alien4 free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/6/2008 23:59'!
testCallingSquenceLongLong2
	| alien1 alien2 result who |
	
	alien1 := Alien newC: 8. 
	alien2 := Alien newC: 8. 
	
	alien1 signedLongLongAt: 1 put: 1.
	alien2 signedLongLongAt: 1 put: 42. 
	
	who := Alien lookup: 'ffiTestLongLong' inLibrary: 'IA32ABI'.
	result := who primFFICallResult: (Alien new: 8)
		with: alien1
		with: alien2.

	self should: [(result signedLongLongAt: 1) = (1+42)].
	alien1 free.
	alien2 free.
! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/8/2008 09:44'!
testCallingSquenceShort
	| alien1 alien2 alien3 alien4 result who |
	
	alien1 := Alien newC: 2. 
	alien2 := Alien newC: 2. 
	alien3 := Alien newC: 2. 
	alien4 := Alien newC: 2. 
	
	alien1 signedShortAt: 1 put: 1.
	alien2 signedShortAt: 1 put: 20. 
	alien3 signedShortAt: 1 put: 30.
	alien4 signedShortAt: 1 put: 40.
	
	who := Alien lookup: 'ffiTestShorts' inLibrary: 'IA32ABI'.
	result := who primFFICallResult: (Alien new: 2)
		with: alien1
		with: alien2
		with: alien3
		with: alien4.
	self should: [(result signedShortAt: 1) = (1+20+30+40)].
	alien1 free.
	alien2 free.
	alien3 free.
	alien4 free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/8/2008 07:01'!
testCallingSquenceString
	| result who alien actualString |
	
	alien := Alien newCString: 'foobardoesitworkwellperhaps'.

	who := Alien lookup: 'ffiPrintString' inLibrary: 'IA32ABI'.
	result := who primFFICallResult: (Alien new: 4) 
		with: alien pointer.
	actualString := Alien atAddress: (result unsignedLongAt: 1) 
		dataSize: (result strlenThroughPointerAt: 1) + 1..
	self should: [(actualString strcpy = 'foobardoesitworkwellperhaps')].
	alien free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 23:44'!
testDoubleAccessors
	| alien |
	alien := Alien newC: 8. 
	alien doubleAt: 1 put: 8.8.
	self should: [(alien doubleAt: 1) = 8.8].
		alien free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 23:44'!
testFloatAccessors
	| alien |
	alien := Alien newC: 4. 
	alien floatAt: 1 put: 8.8.
	self should: [(alien floatAt: 1) closeTo: 8.8].
		alien free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 12/6/2008 14:09'!
testLibCExamples
	| sortedData unsorted sorted |
	
	3 foo.
	sortedData := Alien exampleCqsort.
	unsorted := sortedData key copy.
	sorted := unsorted asSortedCollection.
	self should: [sortedData value = sorted asArray].
	Alien examplePrintf.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/25/2008 22:09'!
testLong
	| long unsignedIntegerIntervalue k signedIntegerIntervalue |
	
	long := Alien newC: 4.
	#( 0 4294967295) do: 
		[:i  | long unsignedLongAt: 1 put: i.
		self should: [(long unsignedLongAt: 1) = i]].
	#( -2147483648 2147483647) do: 
		[:j |  long signedLongAt: 1 put: j.
		self should: [(long signedLongAt: 1) = j]].
	unsignedIntegerIntervalue := (0 to: 4294967295).
	10000 timesRepeat: [
			k := unsignedIntegerIntervalue atRandom.
			long unsignedLongAt: 1 put: k.
			self should: [(long unsignedLongAt: 1) = k]].
	signedIntegerIntervalue := (-2147483648 to: 2147483647).
	10000 timesRepeat: [
			k := signedIntegerIntervalue atRandom.
			long signedLongAt: 1 put: k.
			self should: [(long signedLongAt: 1) = k]].
	
	signedIntegerIntervalue := (-4294967295 to: -2147483649).
	10000 timesRepeat: [
		k := signedIntegerIntervalue atRandom.
		self should: [long signedLongAt: 1 put: k] raise: Error].
	
	signedIntegerIntervalue := (2147483648 to: 4294967295).
	10000 timesRepeat: [
		k := signedIntegerIntervalue atRandom.
		self should: [long signedLongAt: 1 put: k] raise: Error].
	! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 23:44'!
testLongAccessors
	| alien |
	Smalltalk wordSize = 4 ifFalse: [^self].
	
	alien := Alien newC: 4. 
	alien signedLongAt: 1 put: 16r7FFFFFFF.
	self should: [(alien signedLongAt: 1) = 16r7FFFFFFF].
	self should: [(alien asSignedLong) = 16r7FFFFFFF].
	self should: [alien signedLongAt: 1 put: 16r80000000] raise: Error.
	alien signedLongAt: 1 put: -1*16r80000000.
	self should: [(alien signedLongAt: 1) =  (-1*16r80000000)].
	self should: [alien signedLongAt: 1 put: -1*16r80000001] raise: Error.
	alien unsignedLongAt: 1 put: 16r7FFFFFFF.
	self should: [(alien signedLongAt: 1) = 16r7FFFFFFF].
	alien unsignedLongAt: 1 put: 16r80000000.
	self should: [(alien signedLongAt: 1) = -2147483648].
	alien unsignedLongAt: 1 put: 16r80000001.
	self should: [(alien signedLongAt: 1) = -2147483647].
	alien unsignedLongAt: 1 put: 16r7FFFFFFF.
	self should: [(alien unsignedLongAt: 1) = 16r7FFFFFFF]. 
	self should: [(alien asUnsignedLong) = 16r7FFFFFFF]. 
	alien unsignedLongAt: 1 put: 16r80000000.
	self should: [(alien unsignedLongAt: 1) = 16r80000000].
	alien unsignedLongAt: 1 put: 16r80000001.
	self should: [(alien unsignedLongAt: 1) = 16r80000001].
		alien free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/25/2008 22:09'!
testLongLong
	| unsignedIntegerIntervalue k signedIntegerIntervalue longlong |

	longlong := Alien newC: 8.
	#( 0 4294967295 18446744073709551615) do: 
		[:i  | longlong unsignedLongLongAt: 1 put: i.
		self should: [(longlong unsignedLongLongAt: 1) = i]].
	#(-9223372036854775808  -2147483648 2147483647 9223372036854775807) do: 
		[:j |  longlong signedLongLongAt: 1 put: j.
		self should: [(longlong signedLongLongAt: 1) = j]].
	unsignedIntegerIntervalue := (0 to: 18446744073709551615).
	10000 timesRepeat: [
			k := unsignedIntegerIntervalue atRandom.
			longlong unsignedLongLongAt: 1 put: k.
			self should: [(longlong unsignedLongLongAt: 1) = k]].
	signedIntegerIntervalue := (-9223372036854775808 to: 9223372036854775807).
	10000 timesRepeat: [
			k := signedIntegerIntervalue atRandom.
			longlong signedLongLongAt: 1 put: k.
			self should: [(longlong signedLongLongAt: 1) = k]].
	
	signedIntegerIntervalue := (-18446744073709551615 to: -9223372036854775809).
	10000 timesRepeat: [
		k := signedIntegerIntervalue atRandom.
		self should: [longlong signedLongLongAt: 1 put: k] raise: Error].
	
	signedIntegerIntervalue := (9223372036854775808 to: 18446744073709551615).
	10000 timesRepeat: [
		k := signedIntegerIntervalue atRandom.
		self should: [longlong signedLongLongAt: 1 put: k] raise: Error].
	! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 14:20'!
testParser
	"Just confirm it will parse"
	
	(Parser new parse: (MethodNode sourceCodeAt: #primitiveErrorVariableName) class: Parser) primitiveErrorVariableName.
	(Parser new parse: 'foo <primitive: 111 error: ''foo''> self primitiveFailed' class: Object) primitiveErrorVariableName.
	(Parser new parse: 'foo <primitive: 111 error: foo> self primitiveFailed' class: Object) primitiveErrorVariableName.
	(Parser new parse: 'foo <primitive: 111> self primitiveFailed' class: Object) primitiveErrorVariableName.
	(Parser new parse: 'foo <primitive: 111 error: foo> self primitiveFailed' class: Object) generate.
! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 22:00'!
testPointer
	| alien address alias |
	alien := Alien newC: 3.
	address := alien address.
	alias := Alien forPointer: address.
	self should: [alias dataSize = 0].
	self should: [alias address = address].
	alien free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/25/2008 22:09'!
testShort
	| short |
	short := Alien new: 2.
	0 to: 65535 do: 
		[:i  | short unsignedShortAt: 1 put: i.
		self should: [(short unsignedShortAt: 1) = i]].
	-32768 to: 32767 do: 
		[:j |  short signedShortAt: 1 put: j.
		self should: [(short signedShortAt: 1) = j]].
	-65535 to: -32769 do: 
		[:k |  self should: [short signedShortAt: 1 put: k] raise: Error].
	32768 to: 65535 do: 
		[:k |  self should: [short signedShortAt: 1 put: k] raise: Error].! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 23:44'!
testShortAccessors
	| alien |
	alien := Alien newC: 2. 
	alien signedShortAt: 1 put: 16r7FFF.
	self should: [(alien signedShortAt: 1) = 16r7FFF].
	self should: [(alien asSignedShort) = 16r7FFF].
	self should: [alien signedShortAt: 1 put: 16r8000] raise: Error.
	alien signedShortAt: 1 put: -1*16r8000.
	self should: [(alien signedShortAt: 1) =  (-1*16r8000)].
	self should: [alien signedShortAt: 1 put: -1*16r8001] raise: Error.
	alien unsignedShortAt: 1 put: 16r7FFF.
	self should: [(alien signedShortAt: 1) = 16r7FFF].
	alien unsignedShortAt: 1 put: 16r8000.
	self should: [(alien signedShortAt: 1) = -32768].
	alien unsignedShortAt: 1 put: 16r8001.
	self should: [(alien signedShortAt: 1) = -32767].
	alien unsignedShortAt: 1 put: 16r7FFF.
	self should: [(alien unsignedShortAt: 1) = 16r7FFF].
	self should: [(alien asUnsignedShort) = 16r7FFF].
	alien unsignedShortAt: 1 put: 16r8000.
	self should: [(alien unsignedShortAt: 1) = 16r8000].
	alien unsignedShortAt: 1 put: 16r8001.
	self should: [(alien unsignedShortAt: 1) = 16r8001].
		alien free.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 22:00'!
testasAlien
	| alien alienValue |
	alien := Alien newCString: 'foo'.
	self should: [alien == alien asAlien].
	alien free.
	alienValue := false asAlien.
	self should: [alienValue isNumber and: [alienValue == 0]].
	alienValue := true asAlien.
	self should: [alienValue isNumber and: [alienValue == 1]].
	alienValue := nil asAlien.
	self should: [alienValue isNumber and: [alienValue == 0]].! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 15:18'!
testnewC

	| alien |
	alien := 'foo' asAlien.
	self should: [alien strcpy = 'foo'].
	alien free. ! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 15:17'!
testnewGC
	1 foo.! !

!AlienSunit methodsFor: 'testing' stamp: 'John M McIntosh 11/23/2008 23:43'!
teststrcpy

	| alien |
	alien := 'foo' asAlien.
	self should: [alien strcpy = 'foo'].
	self should: [(alien strcpyFrom: 2) = 'oo'].
	alien free.
	alien := 'foo' asAlien.
	self should: [alien strcpyUTF8 = 'foo'].
	self should: [(alien strcpyUTF8From: 2) = 'oo'].
	alien free.
! !
